#
# spec file for package opensp
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           opensp
%define rname opensp
%define doc_package 0
BuildRequires:  gcc-c++ libtool
%if 0%{?doc_package}
BuildRequires:  xmlto
%endif
License:        MIT
Group:          Productivity/Publishing/SGML
Version:        1.5.2
Release:        lp150.1.10
Source:         http://sourceforge.net/projects/openjade/files/opensp/%{version}/OpenSP-%{version}.tar.gz
Patch11:        opensp-nodeids.patch
Patch12:        opensp-lfs.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if 0%{?doc_package}
BuildArch:      noarch
%endif
Url:            http://openjade.sourceforge.net/
%define regcat /usr/bin/sgml-register-catalog
PreReq:         %{regcat}
Summary:        The OpenJade Group's SGML and XML Parsing Tools
Provides:       sp_libs sp OpenSP
Obsoletes:      sp_libs sp

%description
The tools in this package provide the ability to manage SGML and XML
documents.

This package contains the parser nsgmls and the related programs
sgmlnorm, spcat, spam, spent, and sgml2xml (previously known as sx).
Sgml2xml is useful as a tool for converting from SGML to XML, the
coming WWW standard.

This package is a fork from James Clark's SP suite.

%if ! 0%{?doc_package}

%package    -n opensp-devel
License:        MIT
Summary:        SGML parser tools (development package)
Group:          Productivity/Publishing/SGML
Requires:       %{name} = %{version} libstdc++-devel glibc-devel
Provides:       sp-devel OpenSP-devel
Obsoletes:      sp-devel

%description -n opensp-devel
Libraries and includes to compile applications that use the SGML parser
tools (package 'opensp').



%endif
%define INSTALL install -m755 -s
%define INSTALL_DIR install -d -m755
%define INSTALL_DATA install -m644
%define sgml_dir %{_datadir}/sgml
%define sgml_dir_pkg %{sgml_dir}/%{name}
%define sgml_var_dir /var/lib/sgml
%if 0%{?doc_package}
%define MAKE_ARGS -C docsrc
%endif

%prep
%setup -q -n OpenSP-%{version}
# %patch0 -p1
# %patch1 -p1
%patch11 -p1
%patch12

%build
export CFLAGS="$RPM_OPT_FLAGS"
export CXXFLAGS="$RPM_OPT_FLAGS"
autoreconf -fi
# --datadir=%{sgml_dir}/openjade
#  set XMLTO or consider --disable-doc-build
%configure \
            --disable-nls \
            --with-gnu-ld \
            --enable-http \
%if ! 0%{?doc_package}
            --disable-doc-build \
%endif
            --enable-default-catalog="CATALOG:/etc/sgml/catalog:%{sgml_dir}/CATALOG" \
            --disable-static \
            --with-pic
make %{?MAKE_ARGS} %{?_smp_mflags}
perl -pi -e 's/sx/sgml2xml/g; s/SX/SGML2XML/g;' doc/sx.htm
perl -pi -e 's/>sx/>sgml2xml/g; s/>SX/>SGML2XML/g;' doc/{new,index}.htm
# make check

%install
%{INSTALL_DIR} $RPM_BUILD_ROOT%{_libdir}
# %{INSTALL_DIR} $RPM_BUILD_ROOT%{_includedir}/opensp
make %{?MAKE_ARGS} install DESTDIR=$RPM_BUILD_ROOT
%if ! 0%{?doc_package}
make install-man DESTDIR=$RPM_BUILD_ROOT
%endif
# Unwanted doc stuff
rm -fr $RPM_BUILD_ROOT%{_datadir}/{OpenSP,doc} \
  $RPM_BUILD_ROOT%{_prefix}/doc
/sbin/ldconfig -n $RPM_BUILD_ROOT%{_libdir}
# pushd $RPM_BUILD_ROOT%{_includedir}
# ln -sf OpenSP opensp
# ln -sf opensp sp
# popd
%if 0%{?doc_package}
if [ -d $RPM_BUILD_ROOT%{_mandir}/man1 ]; then
  pushd $RPM_BUILD_ROOT%{_mandir}/man1
  cp osx.1 s2x.1
  cp osx.1 osgml2xml.1
  for b in o*; do
    ln -sf ${b} ${b#o}
  done
  rm -f sx*
  popd
fi
%else
pushd $RPM_BUILD_ROOT%{_bindir}
for b in os* onsgmls; do
  ln -sf ${b} ${b#o}
done
# avoid conflict with rzsz package
rm -f sx
ln -sf osx s2x
ln -sf osx sgml2xml
ln -sf osx osgml2xml
popd
%endif
# %{INSTALL_DIR} $RPM_BUILD_ROOT/etc/profile.d
# %{INSTALL_DATA} sp.sh $RPM_BUILD_ROOT/etc/profile.d
%{INSTALL_DIR} $RPM_BUILD_ROOT%{sgml_dir_pkg}
{
  for c in opensp-implied.dcl japan.dcl xml.dcl; do
    %{INSTALL_DATA} pubtext/$c $RPM_BUILD_ROOT%{sgml_dir_pkg}/$c
    echo "-- SGMLDECL \"%{sgml_dir_pkg}/$c\" --"
  done
} > CATALOG.opensp
sed 's|decl|dcl|' pubtext/xml.soc > $RPM_BUILD_ROOT%{sgml_dir_pkg}/xml.soc
%{INSTALL_DIR} $RPM_BUILD_ROOT%{sgml_var_dir}
%{INSTALL_DATA} CATALOG.opensp $RPM_BUILD_ROOT%{sgml_var_dir}
ln -sf ../../../%{sgml_var_dir}/CATALOG.opensp \
  $RPM_BUILD_ROOT%{sgml_dir}/CATALOG.opensp
%{INSTALL_DIR} $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/
{
  echo '# Cf. %{_datadir}/doc/packages/opensp/html/charset.htm'
  echo '# SP_CHARSET_FIXED'
  echo '# SP_SYSTEM_CHARSET'
  echo '# SP_ENCODING'
  echo '# SP_BCTF'
} > opensp.sh
%{INSTALL_DATA} opensp.sh $RPM_BUILD_ROOT%{_sysconfdir}/profile.d/opensp.sh
sed -e 's/\(# \)/\1setenv /' opensp.sh \
  >$RPM_BUILD_ROOT%{_sysconfdir}/profile.d/opensp.csh
rm -fr html
mkdir html
cp doc/catalog doc/*htm html
%define DOCFILES COPYING README NEWS AUTHORS ABOUT-NLS
{
  echo "<html><head><title>OpenSP documentation directory</title></head>"
  echo "<body>"
  for f in %{DOCFILES}; do
    [ -f $f ] || continue
    echo "<a href=\"$f\">$f</a>"
  done
  echo "<a href=\"html/index.htm\">OpenSP</a>, official documentation (html)"
} >index.html
find . -name .cvsignore | xargs rm
%if 0%{?doc_package}
rm -rf $RPM_BUILD_ROOT/etc
rm -rf $RPM_BUILD_ROOT/usr/bin
rm -rf $RPM_BUILD_ROOT/usr/include
rm -rf $RPM_BUILD_ROOT/usr/lib
rm -rf $RPM_BUILD_ROOT/usr/share/doc
rm -rf $RPM_BUILD_ROOT/usr/share/locale
rm -rf $RPM_BUILD_ROOT/usr/share/sgml
rm -rf $RPM_BUILD_ROOT/var
find unicode -name Makefile\* -print -delete
%endif
%if ! 0%{?doc_package}

%post
/sbin/ldconfig
if [ -x %{regcat} ]; then
  %{regcat} -a %{sgml_dir}/CATALOG.opensp >/dev/null 2>&1 || :
fi

%postun
/sbin/ldconfig
if [ "$1" = "0" -a -x %{regcat} ]; then
  %{regcat} -r %{sgml_dir}/CATALOG.opensp >/dev/null 2>&1 || :
fi
%endif

%clean
rm -fr $RPM_BUILD_ROOT

%files
%defattr(-, root, root,755)
%if 0%{?doc_package}
%doc %{DOCFILES} index.html
%doc html
%doc unicode
# pubtext comes with html-dtd
# %doc pubtext
%{_mandir}/*/*sp*
%{_mandir}/*/*s2x*
%{_mandir}/*/*sx*
%{_mandir}/*/*sgml*
%else
%config %{_sysconfdir}/profile.d/opensp.*
%{_bindir}/*nsgmls
%{_bindir}/*sgmlnorm
%{_bindir}/*spcat
%{_bindir}/*spam
%{_bindir}/*spent
%{_bindir}/osx
%{_bindir}/*s2x
%{_bindir}/*sgml2xml
%{_libdir}/lib*.so.*
%{sgml_dir_pkg}
%dir %{sgml_var_dir}
%config %{sgml_var_dir}/CATALOG.opensp
%{sgml_dir}/CATALOG.opensp
# %{_datadir}/locale/*/LC_MESSAGES/*.mo

%files -n opensp-devel
%defattr(-, root, root)
%{_includedir}/OpenSP
%{_libdir}/lib*.so
%exclude %{_libdir}/*a
%endif

%changelog
* Tue Nov 22 2011 coolo@suse.com
- fix source link
* Sun Nov 20 2011 coolo@suse.com
- add libtool as buildrequire to avoid implicit dependency
* Sat Dec 18 2010 cristian.rodriguez@opensuse.org
- use AC_SYS_LARGEFILE, off mismatch between dependant libraries
* Mon Dec 14 2009 jengelh@medozas.de
- enable parallel building
* Fri Nov 14 2008 mrueckert@suse.de
- sync opensp.spec and opensp-doc.spec
* Thu Dec 20 2007 crrodriguez@suse.de
- add missing ldconfig calls
- remove static libraries and "la" files
* Thu May 17 2007 ro@suse.de
- remove xmlto from buildrequires this causes tons of cycles
- split off opensp-doc package in it's own specfile
* Wed May 16 2007 ke@suse.de
- Update to version 1.5.2 (bug fix release); proposed by Sierk
  Bornemann [# 273561].
- Remove obsolete GCC patches.
- Disable NLS.
- Build manpages using xmlto.
- Apply opensp-nodeids.patch from the Fedora opensp-1.5.2-4.fc7.src.rpm
  package.
* Sun Oct 29 2006 meissner@suse.de
- use RPM_OPT_FLAGS also for the C snippets.
* Thu May  4 2006 sbrabec@suse.cz
- Fixed devel dependencies.
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Oct 11 2005 meissner@suse.de
- fixed C++ problem in gcc4.1.
* Wed Apr 21 2004 meissner@suse.de
- removed warnings by adding 2 missing returns.
* Tue Jan 13 2004 meissner@suse.de
- Fixed gcc3.4 build.
* Sat Jan 10 2004 adrian@suse.de
- build as user
* Mon Oct 13 2003 ke@suse.de
- Update to version 1.5.1; from NEWS:
  * With SP_MESSAGE_FORMAT environment variable enable run time
    selection of message format (XML, NONE, TRADITIONAL).
  * Add support for restricted files option to generic API.
  * Add support for http redirection.
  * Add support for specifying the user agent at run time with the
    SP_HTTP_USER_AGENT environment variable.
  * Add support for specifying Accept: headers with the SP_HTTP_ACCEPT
    environment variable.
  * Enhancements to osx. Preserve case option, security fixes,
- Recreate auto* files on SL > 8.0 only.
- Add 'tr' and update 'de' translation file from IRO.UMontreal.CA.
* Mon Oct  6 2003 kukuk@suse.de
- Remove sgml-skel from needed for build
- Add /var/lib/sgml to filelist
* Thu Sep  4 2003 kukuk@suse.de
- opensp-devel should not Obsolete openjade
* Wed Jun  4 2003 kukuk@suse.de
- Fix syntax error in postinstall script
* Mon May 26 2003 ke@suse.de
- Cleanup $RPM_BUILD_ROOT.
* Wed May 21 2003 ke@suse.de
- Use %%postun instead of %%preun and don't run it while updating;
  reported by Ruediger Oertel.
- Don't install .cvsignore file.
* Mon May 19 2003 ro@suse.de
- remove wrong obsoletes for jade_dsl
* Mon May  5 2003 ro@suse.de
- move AttributeValue class declaration to the top of Attribute.h
* Thu Jan 30 2003 ke@suse.de
- Add osx to the %%files list; reported by Togan Muftuoglu.
* Thu Jan 23 2003 coolo@suse.de
- fixing script syntax
* Mon Dec 16 2002 ke@suse.de
- Comment out SGMLDECL statements in CATALOG.opensp; thus the builtin
  SGML declaration will be used.
* Mon Nov 25 2002 ke@suse.de
- Update to version 1.5; from NEWS:
  * Support for "-restricted" option to restrict parsing of web based
    documents to local files only.
  * New spcat cmdline interface to the catalog manager.
  * The multibyte version of OpenSP now uses 32bit chars and supports
    the full UTF-16 range 0x0000-0x10ffff.
  * Support for the koi8-r (RFC 1489) encoding.
  * DTDDECL in SGML Open Catalogs is supported.
  * New options -n and -x to see message numbers/relevant clauses with
    messages.
  * New -output options: comment, omitted, tagomit and attromit; this
    shows comments and implied elements and/or attributes.
  * The architecture engine supports #MAPTOKEN.
  * More of Annex K supported: SGML declarations on subdocs, DATA
    declared value for attributes, DTD data entities and DTD notations
    for doctypes, complete IMPLYDEF support, ENTITIES REF constraints,
    URN parsing. Many new -w flags.
  * More of Annex K supported: Common data attributes can now be
    specified in external entity declarations.
  * Added support for the PI-based architecture use declaration syntax
    defined by Amendment 1 to ISO/IEC 10744:1997 (HyTime).  This makes
    it possible to specify architectural support attributes when using
    architectures with XML, and is generally simpler than the original
    syntax.  See http://www.ornl.gov/sgml/wg8/document/1985.htm for
    details.
  * Adds the architecture public id to the information passed to
    implementations of ArcDirector.  This is especially important when
    using the PI-based architecture use declaration syntax, since there
    may be no Notation object from which to get the information.
  * Add a HTTP/1.0 Host header to HTTP requests. Necessary to fetch DTDs
    specified in SYSTEM identifiers when the DTD resides on a name-based
    "Virtual Host".
  * Enhancements to osx.
  * Add -x command line option to osx, which allows users to say whether
    they want sdata entities transformed into PIs or treated like normal
    entities (the default is the latter, which is how osx always behaved
    before this change).
  * Minor documentation improvements.
  * Update translations: de, fr (new), ja (new)
  * Option to produce error messages formatted as XML
    enable with ./configure --enable-xml-messages
- Register /etc/sgml/opensp.cat using sgml-register-catalog.
- Default catalogs are now: CATALOG, /etc/sgml/catalog, and
  /usr/share/sgml/CATALOG (in this order); /etc/sgml/catalog is new.
- Make it a package on its own (separated from openjade).
* Sat Nov 23 2002 olh@suse.de
- do not fail in pre/postinstall scripts
* Tue Nov 19 2002 ke@suse.de
- Update to version 1.5pre9:
- Make it a package on its own (separated from openjade).
